# -*- coding: iso-8859-1 -*-
##############################################################################
#
# Copyright (c) 2005-2006 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

import wizard
import pooler

view_form_end = """<?xml version="1.0"?>
<form string="System upgrade done">
	<separator string="System upgrade done"/>
	<label string="Selected modules have been upgraded / installed !" colspan="4"/>
	<label string="You may have to reinstall some language pack." colspan="4"/>
	<label string="We suggest you to close all tabs and open a new menu window (Ctrl T)." colspan="4"/>
</form>"""

view_form = """<?xml version="1.0"?>
<form string="System Upgrade">
	<separator string="System Upgrade"/>
	<label string="Your system will be upgraded." colspan="4"/>
	<label string="Note that this operation my take a few minutes."/>
</form>"""

class wizard_info_get(wizard.interface):
	def _upgrade_module(self, cr, uid, data, context):
		pooler.restart_pool(cr.dbname)
		return {}

	states = {
		'init': {
			'actions': [], 
			'result': {'type':'form', 'arch':view_form, 'fields': {}, 'state':[('end','Cancel'),('start','Start Upgrade')]}
		},
		'start': {
			'actions': [_upgrade_module], 
			'result': {'type':'form', 'arch':view_form_end, 'fields': {}, 'state':[('end','Ok')]}
		},
	}
wizard_info_get('module.upgrade')

